/*
 * File:   main.c
 * Author: Paul
 *vated on 15 dcembre 2022, 09:13
 */
// PIC16F84 mont sur carte BlueBird Electronics PCB053  4MHz
// programmateur POK508  aliment en 12V DC
// liaison DB9 F POK508 --- DB9 Male TU-S9 Trend interface RS232/USB 
// verifier que le port virtuel soit declare en #PORT < 4
// voir     as16f684_legacy.h pour les Mnemoniques
// pack,PIC16Fxxx_DFP,1.3.42,Microchip
// xc8\v2.36

#define VERSION "20221216"

#include <xc.h>
#define _16F684
#include <builtins.h>
#include <__at.h>
#define _XTAL_FREQ 4000000   // filtre ceramique sur carte BlueBird Electronics PCB053

// programmateur POK508 et icprog105d.exe
// CONFIG  3FF1  FOSC=XT
#pragma config FOSC = XT        // Oscillator Selection bits (XT oscillator)
#pragma config WDTE = OFF       // Watchdog Timer (WDT disabled)
#pragma config PWRTE = ON       // Power-up Timer Enable bit (Power-up Timer is enabled)
#pragma config CP = OFF         // Code Protection bit (Code protection disabled)

#define Byte uint8_t
#define Word uint16_t


#define  CR 13
#define  LF 10

#define  TX3_Pin  RA2;
#define  TX3_Pin_Dir TRISA2
#define LED_Dir TRISA4
#define LED    RA4


Byte  c3       __at (0x0020);
Byte RS_Count  __at (0x0021);
Byte  RS_tmp   __at (0x0022);
Byte RS_Delay  __at (0x0023);

Word i,j,k;
Byte Texte[32];
Byte * p1;


void UART3_Write_CText(const char *txt3);
void UART3_Write_Text(unsigned char *T) ;
void CRLF3(void);
void UART3_Write(uint8_t cc);  
void strConstRamCpy(unsigned char *dest, const char *source);


// --- Copie le texte depuis FLASH ROM vers RAM
void strConstRamCpy(unsigned char *dest, const char *source)
 {
  while (*source)
  {
      *dest++ = *source++ ;
  }   
  *dest = 0 ;    // terminateur
}


void UART3_Write_CText(const char *txt3)
 {
   while (*txt3)
     {
     UART3_Write(*txt3++);
    __delay_us(500);
     }
}

void UART3_Write_Text(unsigned char *T)    // at adress  0x002 taille 42 bytes
{
  while(*(T)>0)     // verif sur VBRAY en mode ASCII
   {
    UART3_Write(*(T++));   // c3 variable globale
   }
}

void CRLF3()
{
 UART3_Write(CR);
 UART3_Write(LF);
}


void UART3_Write(uint8_t cc)      // 16MHz 19200 bauds
{
   c3=~cc;    // complement du caractere !
    // avec TX3_PIN => RA2
 __asm("    movlw   8 ");
  __asm("   movwf   _RS_Count");
 __asm("    bcf     PORTA,2 ");
  __asm("   call    RSdelai2");
 __asm(" L00:");
 __asm("    rrcf    _c3,1 ");      
 __asm("    btfsc   STATUS,0 ");    
 __asm("    goto    L10    ");  
 __asm("    bsf     PORTA,2  "); 
 __asm("    goto    L20    ");   
 __asm(" L10:");
 __asm("    bcf     PORTA,2  ");    
 __asm(" L20:");
 __asm("    call    RSdelai2  ");        
 __asm("    decfsz  _RS_Count,1 ");  
 __asm("    goto    L00     ");       
 __asm("    bsf     PORTA,2   ");     
 __asm("    call    RSdelai2   ");   
 __asm("    call    RSdelai2  ");   
 __asm("    goto    LA1");
 __asm(" RSdelai2: "); 
 __asm("    MOVLW 28 ");
 __asm("    MOVWF _RS_tmp ");
 __asm(" RS00:");
 __asm("    NOP");
 __asm("    NOP");
 __asm("    NOP");
 __asm("    NOP");
 __asm("    DECFSZ _RS_tmp,F ");
 __asm("    GOTO   RS00 ");
 __asm("    NOP");
 __asm("    NOP");
 __asm("    NOP");
 __asm("    RETURN ");
__asm("  LA1:  ");
 __asm("    nop");
 }

 void main()
 {
 
  PORTA = 0b00000011;
  TRISA = 0b00000011 ;   // PORTA is RA0,1= analog input  RA2=sortie DAC RA3,4,5=Digital output
  PORTA=0;
  LED_Dir=0;
  LED=0;
  TX3_Pin_Dir=0;
 // TX3_Pin = 1;
  RA2=1;
 
   c3=0;
   RS_Count=0;
   RS_tmp=0;
   RS_Delay=0;
   for (i=0;i<sizeof(Texte);i++) Texte[i]=0;
  
   CRLF3();
  strConstRamCpy(Texte," UART 4800 bds Tx sur RA2 \r\n");
 // *(p1)="16F84 32 bytes seulement";
  UART3_Write_Text(Texte);CRLF3();
  j=0;
  do
  {
    UART3_Write((unsigned char)j+48);
     __delay_ms(500);
      __asm ("BSF PORTA,4");
     j++;
     if(j>9)
     {
          j=0;
            // modif 16-12
         UART3_Write(13);
         UART3_Write(10);
     }    
         __delay_ms(500);
         __asm ("BCF PORTA,4");
  
  }   while(1);
  
 }

 
 /*
  
  make -f nbproject/Makefile-default.mk SUBPROJECTS= .build-conf
make[1]: Entering directory 'C:/MPLABX_Projects/16F84_Tests.X'
make  -f nbproject/Makefile-default.mk dist/default/production/16F84_Tests.X.production.hex
make[2]: Entering directory 'C:/MPLABX_Projects/16F84_Tests.X'
"C:\Program Files\Microchip\xc8\v2.36\bin\xc8-cc.exe"  -mcpu=16F84 -c   -mdfp="C:/Program Files/Microchip/MPLABX/v6.00/packs/Microchip/PIC16Fxxx_DFP/1.3.42/xc8"  -fno-short-double -fno-short-float -O0 -fasmfile -maddrqual=require -xassembler-with-cpp -v -mwarn=-3 -Wa,-a -DXPRJ_default=default  -msummary=-psect,-class,+mem,-hex,-file  -ginhx32 -Wl,--data-init -mno-keep-startup -mno-osccal -mno-resetbits -mno-save-resetbits -mno-download -mno-stackcall -mno-default-config-bits   -std=c90 -gdwarf-3 -mstack=compiled:auto:auto     -o build/default/production/main.p1 main.c 
C:\Program Files\Microchip\xc8\v2.36\pic\bin\xc8.exe @C:\Users\Paul\AppData\Local\Temp\xcAs8vox1.cmd [ --xc8cc -q --opt=none --chip=16f84 --dfp=C:/Program Files/Microchip/MPLABX/v6.00/packs/Microchip/PIC16Fxxx_DFP/1.3.42/xc8 --double=32 --float=32 --opt=+asmfile --addrqual=require -P -v --warn=-3 --asmlist -DXPRJ_default=default --summary=-psect,-class,+mem,-hex,-file --output=+inhx32 --runtime=+clear --runtime=+init --runtime=-keep --runtime=-osccal --runtime=-resetbits --runtime=-resetbits --runtime=-download --runtime=-stackcall --runtime=-config --std=c90 --output=+elf:multilocs --stack=compiled:auto:auto -omain.p1 --objdir=build/default/production --outdir=build/default/production main.c --pass1 --callgraph=none --errformat=%f:%l:%c: error: (%n) %s --warnformat=%f:%l:%c: warning: (%n) %s --msgformat=%f:%l:%c: advisory: (%n) %s ]
C:\Program Files\Microchip\xc8\v2.36\pic\bin\picc --xc8cc -q --opt=none --chip=16f84 --dfp=C:/Program Files/Microchip/MPLABX/v6.00/packs/Microchip/PIC16Fxxx_DFP/1.3.42/xc8 --double=32 --float=32 --opt=+asmfile --addrqual=require -P -v --warn=-3 --asmlist -DXPRJ_default=default --summary=-psect,-class,+mem,-hex,-file --output=+inhx32 --runtime=+clear --runtime=+init --runtime=-keep --runtime=-osccal --runtime=-resetbits --runtime=-resetbits --runtime=-download --runtime=-stackcall --runtime=-config --std=c90 --output=+elf:multilocs --stack=compiled:auto:auto -omain.p1 --objdir=build/default/production --outdir=build/default/production main.c --pass1 --callgraph=none --errformat=%f:%l:%c: error: (%n) %s --warnformat=%f:%l:%c: warning: (%n) %s --msgformat=%f:%l:%c: advisory: (%n) %s
C:\Program Files\Microchip\xc8\v2.36\pic\bin\cpp.exe @C:\Users\Paul\AppData\Local\Temp\cpp_xcAs86k.cmd [ -W-3 "--edf=C:\Program Files\Microchip\xc8\v2.36\pic\dat\en_msgs.txt" -DXPRJ_default=default "-IC:/Program Files/Microchip/MPLABX/v6.00/packs/Microchip/PIC16Fxxx_DFP/1.3.42/xc8\pic\include\proc" "-IC:/Program Files/Microchip/MPLABX/v6.00/packs/Microchip/PIC16Fxxx_DFP/1.3.42/xc8\pic\include" "-IC:\Program Files\Microchip\xc8\v2.36\pic\include\c90" "-IC:\Program Files\Microchip\xc8\v2.36\pic\include\proc" "-IC:\Program Files\Microchip\xc8\v2.36\pic\include" -E1 -D_OMNI_CODE_ -D__STACK_COMPILED=1 -D__STACK_HYBRID=2 -D__STACK_REENTRANT=4 -D__STACK=__STACK_COMPILED -D__ADDRQUAL_IGNORE=1 -D__ADDRQUAL_REQUEST=2 -D__ADDRQUAL_REQUIRE=4 -D__ADDRQUAL_REJECT=8 -D__ADDRQUAL=__ADDRQUAL_REQUIRE -D__XC -D__XC8 -D__XC__ -D__XC8__ -D__XC8_VERSION=2360 -DHI_TECH_C -D_HTC_VER_MAJOR_=11 -D_HTC_VER_MINOR_=36 -D_HTC_VER_PLVL_=0 -D_HTC_VER_PATCH_=48 -D__CC_NONE=0x0 -D__CC_RAM=0x1 -D__CODECOV=__CC_NONE -D__OPTIM_FLAGS=0x400102 -D__OPTIM_NONE=0x0 -D__OPTIM_ASM=0x1 -D__OPTIM_ASMFILE=0x2 -D__OPTIM_SPEED=0x20000 -D__OPTIM_3=0x20000 -D__OPTIM_SPACE=0x40000 -D__OPTIM_SIZE=0x40000 -D__OPTIM_S=0x40000 -D__OPTIM_DEBUG=0x80000 -D__OPTIM_G=0x80000 -D__OPTIM_LOCAL=0x200000 -D__OPTIM_1=0x100 -D__OPTIM_2=0x200 -D__OPTIM_LEVEL=0 -D_CLIB_VERSION=1990 -N255 -D_16F84 -D__16F84 -D__16F84__ -D_PIC14 -SP2,2,2,2,2,2,2,2 -S1,2,2,3,4,4,4 -D__PICCPRO__ -D__PICC__ -D_MPC_ -D__XC -D__XC8 -D_HAS_INT24 -D__SIZEOF_CHAR__=1 -D__SIZEOF_SHORT__=2 -D__SIZEOF_INT__=2 -D__SIZEOF_SHORT_LONG__=3 -D__SIZEOF_INT24__=3 -D__SIZEOF___INT24__=3 -D__SIZEOF_LONG__=4 -D__SIZEOF_LONG_LONG__=4 -D__SIZEOF_FLOAT__=4 -D__SIZEOF_DOUBLE__=4 -D__SIZEOF_LONG_DOUBLE__=4 -D_COMMON_=0 -D_BANKCOUNT_=2 -D_BANKBITS_=1 -D_GPRCOUNT_=1 -D_GPRBITS_=0 -D__DATABANK=0 -D__FLASHTYPE=3 -D_NVMREG_INT=2 -D_EEREG_INT=1 -D_NOREG_INT=0 -D_EEPROM_INT=1 -D_ROMSIZE=1024 -D_EEPROMSIZE=64 -DEEPROM_SIZE=64 -D_FLASH_ERASE_SIZE=1 -D_FLASH_WRITE_SIZE=1 "-IC:\Program Files\Microchip\xc8\v2.36\pic\include\legacy" main.c build/default/production\main.i --include=language_support.h ]
C:\Program Files\Microchip\xc8\v2.36\pic\bin\cpp.exe @C:\Users\Paul\AppData\Local\Temp\cpp_xcAs86k.cmd [ -W-3 "--edf=C:\Program Files\Microchip\xc8\v2.36\pic\dat\en_msgs.txt" -DXPRJ_default=default "-IC:/Program Files/Microchip/MPLABX/v6.00/packs/Microchip/PIC16Fxxx_DFP/1.3.42/xc8\pic\include\proc" "-IC:/Program Files/Microchip/MPLABX/v6.00/packs/Microchip/PIC16Fxxx_DFP/1.3.42/xc8\pic\include" "-IC:\Program Files\Microchip\xc8\v2.36\pic\include\c90" "-IC:\Program Files\Microchip\xc8\v2.36\pic\include\proc" "-IC:\Program Files\Microchip\xc8\v2.36\pic\include" -Lgcc -E1 --dep_nosys -D_OMNI_CODE_ -D__STACK_COMPILED=1 -D__STACK_HYBRID=2 -D__STACK_REENTRANT=4 -D__STACK=__STACK_COMPILED -D__ADDRQUAL_IGNORE=1 -D__ADDRQUAL_REQUEST=2 -D__ADDRQUAL_REQUIRE=4 -D__ADDRQUAL_REJECT=8 -D__ADDRQUAL=__ADDRQUAL_REQUIRE -D__XC -D__XC8 -D__XC__ -D__XC8__ -D__XC8_VERSION=2360 -DHI_TECH_C -D_HTC_VER_MAJOR_=11 -D_HTC_VER_MINOR_=36 -D_HTC_VER_PLVL_=0 -D_HTC_VER_PATCH_=48 -D__CC_NONE=0x0 -D__CC_RAM=0x1 -D__CODECOV=__CC_NONE -D__OPTIM_FLAGS=0x400102 -D__OPTIM_NONE=0x0 -D__OPTIM_ASM=0x1 -D__OPTIM_ASMFILE=0x2 -D__OPTIM_SPEED=0x20000 -D__OPTIM_3=0x20000 -D__OPTIM_SPACE=0x40000 -D__OPTIM_SIZE=0x40000 -D__OPTIM_S=0x40000 -D__OPTIM_DEBUG=0x80000 -D__OPTIM_G=0x80000 -D__OPTIM_LOCAL=0x200000 -D__OPTIM_1=0x100 -D__OPTIM_2=0x200 -D__OPTIM_LEVEL=0 -D_CLIB_VERSION=1990 -N255 -D_16F84 -D__16F84 -D__16F84__ -D_PIC14 -SP2,2,2,2,2,2,2,2 -S1,2,2,3,4,4,4 -D__PICCPRO__ -D__PICC__ -D_MPC_ -D__XC -D__XC8 -D_HAS_INT24 -D__SIZEOF_CHAR__=1 -D__SIZEOF_SHORT__=2 -D__SIZEOF_INT__=2 -D__SIZEOF_SHORT_LONG__=3 -D__SIZEOF_INT24__=3 -D__SIZEOF___INT24__=3 -D__SIZEOF_LONG__=4 -D__SIZEOF_LONG_LONG__=4 -D__SIZEOF_FLOAT__=4 -D__SIZEOF_DOUBLE__=4 -D__SIZEOF_LONG_DOUBLE__=4 -D_COMMON_=0 -D_BANKCOUNT_=2 -D_BANKBITS_=1 -D_GPRCOUNT_=1 -D_GPRBITS_=0 -D__DATABANK=0 -D__FLASHTYPE=3 -D_NVMREG_INT=2 -D_EEREG_INT=1 -D_NOREG_INT=0 -D_EEPROM_INT=1 -D_ROMSIZE=1024 -D_EEPROMSIZE=64 -DEEPROM_SIZE=64 -D_FLASH_ERASE_SIZE=1 -D_FLASH_WRITE_SIZE=1 "-IC:\Program Files\Microchip\xc8\v2.36\pic\include\legacy" main.c build/default/production\main.d --include=language_support.h ]
C:\Program Files\Microchip\xc8\v2.36\pic\bin\p1.exe @C:\Users\Paul\AppData\Local\Temp\p1_xcAs86k.cmd [ -W-3 "--edf=C:\Program Files\Microchip\xc8\v2.36\pic\dat\en_msgs.txt" --cmode=htc -Tunsupported,s -Tdeprecated -Taddress,i --longlong=0 -QF_,0,far -QN_,0,near -QI_,0,interrupt -QS_,0,persistent -QT_,0,inline -QQ,0,__pack -QJ_,0,nonreentrant -QJ_,0,compiled -QU,0,__discrete -QE_,0,eeprom -QL_,0,low_priority -QH_,0,high_priority -QAx,0,__minocg -Q00,1512,__invariant -Q00,1512,__stable -Q00,0,restrict -QP_s,0,bank0 -QX_s,0,bank1 -QY_s,0,bank2 -QZ_s,0,bank3 -QCu,0,const -QR_0,1463,reentrant -QBu,0,__rom -QMu,0,__ram -v -N255 -E1 -S -u -fp "--cfgdata=C:/Program Files/Microchip/MPLABX/v6.00/packs/Microchip/PIC16Fxxx_DFP/1.3.42/xc8\pic\dat\cfgdata\16f84.cfgdata" "--cfgmap=C:/Program Files/Microchip/MPLABX/v6.00/packs/Microchip/PIC16Fxxx_DFP/1.3.42/xc8\pic\dat\cfgmap\16f84.cfgmap" -Gstrings,const -M -B -J -Y -r -RI --constauto build/default/production\main.i build/default/production\main.p1 C:\Users\Paul\AppData\Local\Temp\xcAs86k.9 ]
main.c:94:7: warning: (373) implicit signed to unsigned conversion
main.c:159:32: warning: (373) implicit signed to unsigned conversion
del C:\Users\Paul\AppData\Local\Temp\cpp_xcAs86k.cmd
del C:\Users\Paul\AppData\Local\Temp\p1_xcAs86k.cmd
"C:\Program Files\Microchip\xc8\v2.36\bin\xc8-cc.exe"  -mcpu=16F84 -Wl,-Map=dist/default/production/16F84_Tests.X.production.map  -DXPRJ_default=default  -Wl,--defsym=__MPLAB_BUILD=1   -mdfp="C:/Program Files/Microchip/MPLABX/v6.00/packs/Microchip/PIC16Fxxx_DFP/1.3.42/xc8"  -fno-short-double -fno-short-float -O0 -fasmfile -maddrqual=require -xassembler-with-cpp -v -mwarn=-3 -Wa,-a -msummary=-psect,-class,+mem,-hex,-file  -ginhx32 -Wl,--data-init -mno-keep-startup -mno-osccal -mno-resetbits -mno-save-resetbits -mno-download -mno-stackcall -mno-default-config-bits -std=c90 -gdwarf-3 -mstack=compiled:auto:auto      -Wl,--memorysummary,dist/default/production/memoryfile.xml -o dist/default/production/16F84_Tests.X.production.elf  build/default/production/main.p1     
C:\Program Files\Microchip\xc8\v2.36\pic\bin\xc8.exe @C:\Users\Paul\AppData\Local\Temp\xcAs1pox1.cmd [ --xc8cc -q --opt=none --chip=16f84 -Mdist/default/production/16F84_Tests.X.production.map -DXPRJ_default=default -L--defsym=__MPLAB_BUILD=1 --dfp=C:/Program Files/Microchip/MPLABX/v6.00/packs/Microchip/PIC16Fxxx_DFP/1.3.42/xc8 --double=32 --float=32 --opt=+asmfile --addrqual=require -P -v --warn=-3 --asmlist --summary=-psect,-class,+mem,-hex,-file --output=+inhx32 --runtime=+clear --runtime=+init --runtime=-keep --runtime=-osccal --runtime=-resetbits --runtime=-resetbits --runtime=-download --runtime=-stackcall --runtime=-config --std=c90 --output=+elf:multilocs --stack=compiled:auto:auto --summary=+xml --summarydir=dist/default/production/memoryfile.xml -o16F84_Tests.X.production.elf --objdir=dist/default/production --outdir=dist/default/production build/default/production/main.p1 --callgraph=none --errformat=%f:%l:%c: error: (%n) %s --warnformat=%f:%l:%c: warning: (%n) %s --msgformat=%f:%l:%c: advisory: (%n) %s ]
C:\Program Files\Microchip\xc8\v2.36\pic\bin\picc --xc8cc -q --opt=none --chip=16f84 -Mdist/default/production/16F84_Tests.X.production.map -DXPRJ_default=default -L--defsym=__MPLAB_BUILD=1 --dfp=C:/Program Files/Microchip/MPLABX/v6.00/packs/Microchip/PIC16Fxxx_DFP/1.3.42/xc8 --double=32 --float=32 --opt=+asmfile --addrqual=require -P -v --warn=-3 --asmlist --summary=-psect,-class,+mem,-hex,-file --output=+inhx32 --runtime=+clear --runtime=+init --runtime=-keep --runtime=-osccal --runtime=-resetbits --runtime=-resetbits --runtime=-download --runtime=-stackcall --runtime=-config --std=c90 --output=+elf:multilocs --stack=compiled:auto:auto --summary=+xml --summarydir=dist/default/production/memoryfile.xml -o16F84_Tests.X.production.elf --objdir=dist/default/production --outdir=dist/default/production build/default/production/main.p1 --callgraph=none --errformat=%f:%l:%c: error: (%n) %s --warnformat=%f:%l:%c: warning: (%n) %s --msgformat=%f:%l:%c: advisory: (%n) %s
C:\Program Files\Microchip\xc8\v2.36\pic\bin\cpp.exe @C:\Users\Paul\AppData\Local\Temp\cpp_xcAsbig.cmd [ -W-3 "--edf=C:\Program Files\Microchip\xc8\v2.36\pic\dat\en_msgs.txt" -DXPRJ_default=default "-IC:/Program Files/Microchip/MPLABX/v6.00/packs/Microchip/PIC16Fxxx_DFP/1.3.42/xc8\pic\include\proc" "-IC:/Program Files/Microchip/MPLABX/v6.00/packs/Microchip/PIC16Fxxx_DFP/1.3.42/xc8\pic\include" "-IC:\Program Files\Microchip\xc8\v2.36\pic\include\c90" "-IC:\Program Files\Microchip\xc8\v2.36\pic\include\proc" "-IC:\Program Files\Microchip\xc8\v2.36\pic\include" -E1 -D_OMNI_CODE_ -D__STACK_COMPILED=1 -D__STACK_HYBRID=2 -D__STACK_REENTRANT=4 -D__STACK=__STACK_COMPILED -D__ADDRQUAL_IGNORE=1 -D__ADDRQUAL_REQUEST=2 -D__ADDRQUAL_REQUIRE=4 -D__ADDRQUAL_REJECT=8 -D__ADDRQUAL=__ADDRQUAL_REQUIRE -D__XC -D__XC8 -D__XC__ -D__XC8__ -D__XC8_VERSION=2360 -DHI_TECH_C -D_HTC_VER_MAJOR_=11 -D_HTC_VER_MINOR_=36 -D_HTC_VER_PLVL_=0 -D_HTC_VER_PATCH_=48 -D__CC_NONE=0x0 -D__CC_RAM=0x1 -D__CODECOV=__CC_NONE -D__OPTIM_FLAGS=0x400102 -D__OPTIM_NONE=0x0 -D__OPTIM_ASM=0x1 -D__OPTIM_ASMFILE=0x2 -D__OPTIM_SPEED=0x20000 -D__OPTIM_3=0x20000 -D__OPTIM_SPACE=0x40000 -D__OPTIM_SIZE=0x40000 -D__OPTIM_S=0x40000 -D__OPTIM_DEBUG=0x80000 -D__OPTIM_G=0x80000 -D__OPTIM_LOCAL=0x200000 -D__OPTIM_1=0x100 -D__OPTIM_2=0x200 -D__OPTIM_LEVEL=0 -D_CLIB_VERSION=1990 -N255 -D_16F84 -D__16F84 -D__16F84__ -D_PIC14 -SP2,2,2,2,2,2,2,2 -S1,2,2,3,4,4,4 -D__PICCPRO__ -D__PICC__ -D_MPC_ -D__XC -D__XC8 -D_HAS_INT24 -D__SIZEOF_CHAR__=1 -D__SIZEOF_SHORT__=2 -D__SIZEOF_INT__=2 -D__SIZEOF_SHORT_LONG__=3 -D__SIZEOF_INT24__=3 -D__SIZEOF___INT24__=3 -D__SIZEOF_LONG__=4 -D__SIZEOF_LONG_LONG__=4 -D__SIZEOF_FLOAT__=4 -D__SIZEOF_DOUBLE__=4 -D__SIZEOF_LONG_DOUBLE__=4 -D_COMMON_=0 -D_BANKCOUNT_=2 -D_BANKBITS_=1 -D_GPRCOUNT_=1 -D_GPRBITS_=0 -D__DATABANK=0 -D__FLASHTYPE=3 -D_NVMREG_INT=2 -D_EEREG_INT=1 -D_NOREG_INT=0 -D_EEPROM_INT=1 -D_ROMSIZE=1024 -D_EEPROMSIZE=64 -DEEPROM_SIZE=64 -D_FLASH_ERASE_SIZE=1 -D_FLASH_WRITE_SIZE=1 "-IC:\Program Files\Microchip\xc8\v2.36\pic\include\legacy" "C:\Program Files\Microchip\xc8\v2.36\pic\sources\c90\pic\__eeprom.c" dist/default/production\__eeprom.i --include=language_support.h ]
C:\Program Files\Microchip\xc8\v2.36\pic\bin\cpp.exe @C:\Users\Paul\AppData\Local\Temp\cpp_xcAsbig.cmd [ -W-3 "--edf=C:\Program Files\Microchip\xc8\v2.36\pic\dat\en_msgs.txt" -DXPRJ_default=default "-IC:/Program Files/Microchip/MPLABX/v6.00/packs/Microchip/PIC16Fxxx_DFP/1.3.42/xc8\pic\include\proc" "-IC:/Program Files/Microchip/MPLABX/v6.00/packs/Microchip/PIC16Fxxx_DFP/1.3.42/xc8\pic\include" "-IC:\Program Files\Microchip\xc8\v2.36\pic\include\c90" "-IC:\Program Files\Microchip\xc8\v2.36\pic\include\proc" "-IC:\Program Files\Microchip\xc8\v2.36\pic\include" -Lgcc -E1 --dep_nosys -D_OMNI_CODE_ -D__STACK_COMPILED=1 -D__STACK_HYBRID=2 -D__STACK_REENTRANT=4 -D__STACK=__STACK_COMPILED -D__ADDRQUAL_IGNORE=1 -D__ADDRQUAL_REQUEST=2 -D__ADDRQUAL_REQUIRE=4 -D__ADDRQUAL_REJECT=8 -D__ADDRQUAL=__ADDRQUAL_REQUIRE -D__XC -D__XC8 -D__XC__ -D__XC8__ -D__XC8_VERSION=2360 -DHI_TECH_C -D_HTC_VER_MAJOR_=11 -D_HTC_VER_MINOR_=36 -D_HTC_VER_PLVL_=0 -D_HTC_VER_PATCH_=48 -D__CC_NONE=0x0 -D__CC_RAM=0x1 -D__CODECOV=__CC_NONE -D__OPTIM_FLAGS=0x400102 -D__OPTIM_NONE=0x0 -D__OPTIM_ASM=0x1 -D__OPTIM_ASMFILE=0x2 -D__OPTIM_SPEED=0x20000 -D__OPTIM_3=0x20000 -D__OPTIM_SPACE=0x40000 -D__OPTIM_SIZE=0x40000 -D__OPTIM_S=0x40000 -D__OPTIM_DEBUG=0x80000 -D__OPTIM_G=0x80000 -D__OPTIM_LOCAL=0x200000 -D__OPTIM_1=0x100 -D__OPTIM_2=0x200 -D__OPTIM_LEVEL=0 -D_CLIB_VERSION=1990 -N255 -D_16F84 -D__16F84 -D__16F84__ -D_PIC14 -SP2,2,2,2,2,2,2,2 -S1,2,2,3,4,4,4 -D__PICCPRO__ -D__PICC__ -D_MPC_ -D__XC -D__XC8 -D_HAS_INT24 -D__SIZEOF_CHAR__=1 -D__SIZEOF_SHORT__=2 -D__SIZEOF_INT__=2 -D__SIZEOF_SHORT_LONG__=3 -D__SIZEOF_INT24__=3 -D__SIZEOF___INT24__=3 -D__SIZEOF_LONG__=4 -D__SIZEOF_LONG_LONG__=4 -D__SIZEOF_FLOAT__=4 -D__SIZEOF_DOUBLE__=4 -D__SIZEOF_LONG_DOUBLE__=4 -D_COMMON_=0 -D_BANKCOUNT_=2 -D_BANKBITS_=1 -D_GPRCOUNT_=1 -D_GPRBITS_=0 -D__DATABANK=0 -D__FLASHTYPE=3 -D_NVMREG_INT=2 -D_EEREG_INT=1 -D_NOREG_INT=0 -D_EEPROM_INT=1 -D_ROMSIZE=1024 -D_EEPROMSIZE=64 -DEEPROM_SIZE=64 -D_FLASH_ERASE_SIZE=1 -D_FLASH_WRITE_SIZE=1 "-IC:\Program Files\Microchip\xc8\v2.36\pic\include\legacy" "C:\Program Files\Microchip\xc8\v2.36\pic\sources\c90\pic\__eeprom.c" dist/default/production\__eeprom.d --include=language_support.h ]
C:\Program Files\Microchip\xc8\v2.36\pic\bin\p1.exe @C:\Users\Paul\AppData\Local\Temp\p1_xcAsbig.cmd [ -W-3 "--edf=C:\Program Files\Microchip\xc8\v2.36\pic\dat\en_msgs.txt" --cmode=htc -Tunsupported,s -Tdeprecated -Taddress,i --longlong=0 -QF_,0,far -QN_,0,near -QI_,0,interrupt -QS_,0,persistent -QT_,0,inline -QQ,0,__pack -QJ_,0,nonreentrant -QJ_,0,compiled -QU,0,__discrete -QE_,0,eeprom -QL_,0,low_priority -QH_,0,high_priority -QAx,0,__minocg -Q00,1512,__invariant -Q00,1512,__stable -Q00,0,restrict -QP_s,0,bank0 -QX_s,0,bank1 -QY_s,0,bank2 -QZ_s,0,bank3 -QCu,0,const -QR_0,1463,reentrant -QBu,0,__rom -QMu,0,__ram -v -N255 -E1 -S -u -fp "--cfgdata=C:/Program Files/Microchip/MPLABX/v6.00/packs/Microchip/PIC16Fxxx_DFP/1.3.42/xc8\pic\dat\cfgdata\16f84.cfgdata" "--cfgmap=C:/Program Files/Microchip/MPLABX/v6.00/packs/Microchip/PIC16Fxxx_DFP/1.3.42/xc8\pic\dat\cfgmap\16f84.cfgmap" -Gstrings,const -M -B -J -Y -r -RI --constauto dist/default/production\__eeprom.i dist/default/production\__eeprom.p1 C:\Users\Paul\AppData\Local\Temp\xcAsbig.9 ]
C:\Program Files\Microchip\xc8\v2.36\pic\bin\cgpic.exe @C:\Users\Paul\AppData\Local\Temp\cgpic_xcAsbig.cmd [ -W-3 "--edf=C:\Program Files\Microchip\xc8\v2.36\pic\dat\en_msgs.txt" --cmode=htc -Og1 --cacheconst=auto --std=c90 --stdlib=c90 -q -E1 -w9 --ivtinit=none "-CC:/Program Files/Microchip/MPLABX/v6.00/packs/Microchip/PIC16Fxxx_DFP/1.3.42/xc8\pic\dat\ini\16f84.ini" -PPIC16F84 -PMS0:code:400000@CODE=00h-03FFh -PMS0:code:400000@STRCODE=00h-03FFh -PMS0:code:400000@STRING=00h-0FFhx4 -PMS0:code:400000@CONST=00h-0FFhx4 -PMS0:code:400000@ENTRY=00h-0FFhx4 -PMS1:data:0@BANK0=0Ch-04Dh -PMS1:data:0@RAM=0Ch-04Dh -PMS1:data:0@ABS1=0Ch-04Fh -PMS1:data:8@COMMON=04Eh-04Fh -PMS1:data:0@SFR0=00h-0Bh -PMS1:data:0@SFR1=080h-0CDh -PMS3:eedata:400000@EEDATA=00h-03Fh/02100h -PMS4:config:400000@CONFIG=02007h-02007h -PMS5:idloc:400000@IDLOC=02000h-02003h "--cfgdata=C:/Program Files/Microchip/MPLABX/v6.00/packs/Microchip/PIC16Fxxx_DFP/1.3.42/xc8\pic\dat\cfgdata\16f84.cfgdata" --cfgprefix=__CFG_ "--cgen_inc=C:/Program Files/Microchip/MPLABX/v6.00/packs/Microchip/PIC16Fxxx_DFP/1.3.42/xc8\pic\include\proc" --stack=compiled -MIEEE_DBL -MIEEE_FLT -fp -AC:\Users\Paul\AppData\Local\Temp\xcAsbig.s --funcdat=C:\Users\Paul\AppData\Local\Temp\xcAsbig.3 --addrqual=require --runtime=init --runtime=clear --ll=0 --undefints=ignore --pragmaconfig=as --md=C:\Users\Paul\AppData\Local\Temp\xcAsbig.dat build/default/production/main.p1 dist/default/production\__eeprom.p1 "C:\Program Files\Microchip\xc8\v2.36\pic\lib\c90\pic-intlib-d32-sz.a" "C:\Program Files\Microchip\xc8\v2.36\pic\lib\c90\pic-stdlib-d32-sz.a" ]
C:\Program Files\Microchip\xc8\v2.36\pic\bin\cgpic.exe @C:\Users\Paul\AppData\Local\Temp\cgpic_xcAsbig.cmd [ -W-3 "--edf=C:\Program Files\Microchip\xc8\v2.36\pic\dat\en_msgs.txt" --cmode=htc -Og1 --cacheconst=auto --std=c90 --stdlib=c90 -q -E1 -Ddist/default/production\16F84_Tests.X.production.sdb --interrupts=0 --ivtinit=none "-CC:/Program Files/Microchip/MPLABX/v6.00/packs/Microchip/PIC16Fxxx_DFP/1.3.42/xc8\pic\dat\ini\16f84.ini" -PPIC16F84 -PMS0:code:400000@CODE=00h-03FFh -PMS0:code:400000@STRCODE=00h-03FFh -PMS0:code:400000@STRING=00h-0FFhx4 -PMS0:code:400000@CONST=00h-0FFhx4 -PMS0:code:400000@ENTRY=00h-0FFhx4 -PMS1:data:0@BANK0=0Ch-04Dh -PMS1:data:0@RAM=0Ch-04Dh -PMS1:data:0@ABS1=0Ch-04Fh -PMS1:data:8@COMMON=04Eh-04Fh -PMS1:data:0@SFR0=00h-0Bh -PMS1:data:0@SFR1=080h-0CDh -PMS3:eedata:400000@EEDATA=00h-03Fh/02100h -PMS4:config:400000@CONFIG=02007h-02007h -PMS5:idloc:400000@IDLOC=02000h-02003h "--cfgdata=C:/Program Files/Microchip/MPLABX/v6.00/packs/Microchip/PIC16Fxxx_DFP/1.3.42/xc8\pic\dat\cfgdata\16f84.cfgdata" --cfgprefix=__CFG_ "--cgen_inc=C:/Program Files/Microchip/MPLABX/v6.00/packs/Microchip/PIC16Fxxx_DFP/1.3.42/xc8\pic\include\proc" --stack=compiled -MIEEE_DBL -MIEEE_FLT -AC:\Users\Paul\AppData\Local\Temp\xcAsbig.s --funcdat=C:\Users\Paul\AppData\Local\Temp\xcAsbig.3 --addrqual=require --runtime=init --runtime=clear --ll=0 --volsfrs=88h-89h --undefints=ignore --pragmaconfig=as --md=C:\Users\Paul\AppData\Local\Temp\xcAsbig.dat build/default/production/main.p1 dist/default/production\__eeprom.p1 "C:\Program Files\Microchip\xc8\v2.36\pic\lib\c90\pic-intlib-d32-sz.a" "C:\Program Files\Microchip\xc8\v2.36\pic\lib\c90\pic-stdlib-d32-sz.a" ]
Non line specific message::: advisory: (1492) using updated 32-bit floating-point libraries; improved accuracy might increase code size
main.c:68:: warning: (520) function "_UART3_Write_CText" is never called
C:\Program Files\Microchip\xc8\v2.36\pic\bin\aspic.exe @C:\Users\Paul\AppData\Local\Temp\aspic_xcAsbig.cmd [ -W-3 "--edf=C:\Program Files\Microchip\xc8\v2.36\pic\dat\en_msgs.txt" --cmode=htc -E1 "--cfgdata=C:/Program Files/Microchip/MPLABX/v6.00/packs/Microchip/PIC16Fxxx_DFP/1.3.42/xc8\pic\dat\cfgdata\16f84.cfgdata" "-CC:/Program Files/Microchip/MPLABX/v6.00/packs/Microchip/PIC16Fxxx_DFP/1.3.42/xc8\pic\dat\ini\16f84.ini" -ver=V2.36 -ldist/default/production\16F84_Tests.X.production.lst --opt= -mcpu=16F84 -R400 -I -no_bankop --prog=00h-03FFh -odist/default/production\16F84_Tests.X.production.o C:\Users\Paul\AppData\Local\Temp\xcAsbig.s ]
C:\Program Files\Microchip\xc8\v2.36\pic\bin\aspic.exe @C:\Users\Paul\AppData\Local\Temp\aspic_xcAsbig.cmd [ -W-3 "--edf=C:\Program Files\Microchip\xc8\v2.36\pic\dat\en_msgs.txt" --cmode=htc -E1 "--cfgdata=C:/Program Files/Microchip/MPLABX/v6.00/packs/Microchip/PIC16Fxxx_DFP/1.3.42/xc8\pic\dat\cfgdata\16f84.cfgdata" "-CC:/Program Files/Microchip/MPLABX/v6.00/packs/Microchip/PIC16Fxxx_DFP/1.3.42/xc8\pic\dat\ini\16f84.ini" -ver=V2.36 --opt= -mcpu=16F84 -R400 -I -no_bankop --prog=00h-03FFh -oC:\Users\Paul\AppData\Local\Temp\xcAsbig.o C:\Users\Paul\AppData\Local\Temp\xcAsbig.s ]
C:\Program Files\Microchip\xc8\v2.36\pic\bin\hlink.exe @C:\Users\Paul\AppData\Local\Temp\hlink_xcAsbig.cmd [ -W-3 "--edf=C:\Program Files\Microchip\xc8\v2.36\pic\dat\en_msgs.txt" -cn -h+dist/default/production\16F84_Tests.X.production.sym --cmf=dist/default/production\16F84_Tests.X.production.cmf -z -w9 --disl=596:off --norlf -Q16F84 -oC:\Users\Paul\AppData\Local\Temp\xcAsbig.4 --defsym=__MPLAB_BUILD=1 -Mdist/default/production/16F84_Tests.X.production.map --md=C:\Users\Paul\AppData\Local\Temp\xcAsbig.dat -E1 -ver=XC8^Compiler#PRO##V2.36 --acfsm=1493 -ACODE=00h-03FFh -ASTRCODE=00h-03FFh -ASTRING=00h-0FFhx4 -ACONST=00h-0FFhx4 -AENTRY=00h-0FFhx4 -ABANK0=0Ch-04Dh -ARAM=0Ch-04Dh -AABS1=0Ch-04Fh -ACOMMON=04Eh-04Fh -ASFR0=00h-0Bh -ASFR1=080h-0CDh -ACONFIG=02007h-02007h -DCONFIG=2 -AIDLOC=02000h-02003h -DIDLOC=2 -AEEDATA=00h-03Fh/02100h -peeprom_data=EEDATA -DEEDATA=2 -DCODE=2 -DSTRCODE=2 -DSTRING=2 -DCONST=2 -DENTRY=2 -preset_vec=00h,intentry,init,end_init -ppowerup=CODE -pcinit=CODE -pfunctab=ENTRY -k C:\Users\Paul\AppData\Local\Temp\xcAsbig.o dist/default/production\16F84_Tests.X.production.o ]
C:\Program Files\Microchip\xc8\v2.36\pic\bin\aspic.exe @C:\Users\Paul\AppData\Local\Temp\aspic_xcAsbig.cmd [ -W-3 "--edf=C:\Program Files\Microchip\xc8\v2.36\pic\dat\en_msgs.txt" --cmode=htc -E1 "--cfgdata=C:/Program Files/Microchip/MPLABX/v6.00/packs/Microchip/PIC16Fxxx_DFP/1.3.42/xc8\pic\dat\cfgdata\16f84.cfgdata" "-CC:/Program Files/Microchip/MPLABX/v6.00/packs/Microchip/PIC16Fxxx_DFP/1.3.42/xc8\pic\dat\ini\16f84.ini" -ver=V2.36 --opt= -mcpu=16F84 -R400 -I -no_bankop --prog=00h-03FFh -oC:\Users\Paul\AppData\Local\Temp\xcAsbig.o C:\Users\Paul\AppData\Local\Temp\xcAsbig.s ]
C:\Program Files\Microchip\xc8\v2.36\pic\bin\hlink.exe @C:\Users\Paul\AppData\Local\Temp\hlink_xcAsbig.cmd [ -W-3 "--edf=C:\Program Files\Microchip\xc8\v2.36\pic\dat\en_msgs.txt" -cn -h+dist/default/production\16F84_Tests.X.production.sym --cmf=dist/default/production\16F84_Tests.X.production.cmf -z -Q16F84 -oC:\Users\Paul\AppData\Local\Temp\xcAsbig.4 --defsym=__MPLAB_BUILD=1 -Mdist/default/production/16F84_Tests.X.production.map --md=C:\Users\Paul\AppData\Local\Temp\xcAsbig.dat -E1 -ver=XC8^Compiler#PRO##V2.36 --acfsm=1493 -ACODE=00h-03FFh -ASTRCODE=00h-03FFh -ASTRING=00h-0FFhx4 -ACONST=00h-0FFhx4 -AENTRY=00h-0FFhx4 -ABANK0=0Ch-04Dh -ARAM=0Ch-04Dh -AABS1=0Ch-04Fh -ACOMMON=04Eh-04Fh -ASFR0=00h-0Bh -ASFR1=080h-0CDh -ACONFIG=02007h-02007h -DCONFIG=2 -AIDLOC=02000h-02003h -DIDLOC=2 -AEEDATA=00h-03Fh/02100h -peeprom_data=EEDATA -DEEDATA=2 -DCODE=2 -DSTRCODE=2 -DSTRING=2 -DCONST=2 -DENTRY=2 -preset_vec=00h,intentry,init,end_init -ppowerup=CODE -pcinit=CODE -pfunctab=ENTRY -k C:\Users\Paul\AppData\Local\Temp\xcAsbig.o dist/default/production\16F84_Tests.X.production.o ]
C:\Program Files\Microchip\xc8\v2.36\pic\bin\objtohex.exe @C:\Users\Paul\AppData\Local\Temp\objtohex_xcAsbig.cmd [ -W-3 "--edf=C:\Program Files\Microchip\xc8\v2.36\pic\dat\en_msgs.txt" -i -j -16,1 C:\Users\Paul\AppData\Local\Temp\xcAsbig.4 dist/default/production\16F84_Tests.X.production.hex ]
C:\Program Files\Microchip\xc8\v2.36\pic\bin\cromwell.exe @C:\Users\Paul\AppData\Local\Temp\cromwell_xcAsbig.cmd [ -W-3 "--edf=C:\Program Files\Microchip\xc8\v2.36\pic\dat\en_msgs.txt" --dwarf-addr-size=2 -m -P16F84,PIC14 --dwarf-use-ranges=auto --dwarf-use-loclists=always --code-spaces=0,3,4,5 --data-spaces=1,2,7 --code-delta=2 dist/default/production\16F84_Tests.X.production.hex dist/default/production\16F84_Tests.X.production.cmf -oelf -E1 --eeprom-spaces=3 ]

Memory Summary:
    Program space        used   109h (   265) of   400h words   ( 25.9%)
    Data space           used    34h (    52) of    44h bytes   ( 76.5%)
    EEPROM space         used     0h (     0) of    40h bytes   (  0.0%)
    Configuration bits   used     1h (     1) of     1h word    (100.0%)
    ID Location space    used     0h (     0) of     4h bytes   (  0.0%)

del C:\Users\Paul\AppData\Local\Temp\xcAsbig.dat
del C:\Users\Paul\AppData\Local\Temp\xcAsbig.s
del C:\Users\Paul\AppData\Local\Temp\xcAsbig.3
del C:\Users\Paul\AppData\Local\Temp\xcAsbig.4
del C:\Users\Paul\AppData\Local\Temp\cpp_xcAsbig.cmd
del C:\Users\Paul\AppData\Local\Temp\p1_xcAsbig.cmd
del C:\Users\Paul\AppData\Local\Temp\cgpic_xcAsbig.cmd
del C:\Users\Paul\AppData\Local\Temp\aspic_xcAsbig.cmd
del C:\Users\Paul\AppData\Local\Temp\xcAsbig.
del C:\Users\Paul\AppData\Local\Temp\xcAsbig.o
del C:\Users\Paul\AppData\Local\Temp\hlink_xcAsbig.cmd
del C:\Users\Paul\AppData\Local\Temp\objtohex_xcAsbig.cmd
del C:\Users\Paul\AppData\Local\Temp\cromwell_xcAsbig.cmd
make[2]: Leaving directory 'C:/MPLABX_Projects/16F84_Tests.X'
make[1]: Leaving directory 'C:/MPLABX_Projects/16F84_Tests.X'

BUILD SUCCESSFUL (total time: 2s)

Searching project "16F84_Tests" for header files...
Header file excluded from package: C:/Program Files/Microchip/MPLABX/v6.00/packs/Microchip/PIC16Fxxx_DFP/1.3.42/xc8/pic/include/__at.h
Header file excluded from package: C:/Program Files/Microchip/MPLABX/v6.00/packs/Microchip/PIC16Fxxx_DFP/1.3.42/xc8/pic/include/builtins.h
Header file excluded from package: C:/Program Files/Microchip/MPLABX/v6.00/packs/Microchip/PIC16Fxxx_DFP/1.3.42/xc8/pic/include/eeprom_routines.h
Header file excluded from package: C:/Program Files/Microchip/MPLABX/v6.00/packs/Microchip/PIC16Fxxx_DFP/1.3.42/xc8/pic/include/htc.h
Header file excluded from package: C:/Program Files/Microchip/MPLABX/v6.00/packs/Microchip/PIC16Fxxx_DFP/1.3.42/xc8/pic/include/language_support.h
Header file excluded from package: C:/Program Files/Microchip/MPLABX/v6.00/packs/Microchip/PIC16Fxxx_DFP/1.3.42/xc8/pic/include/pic.h
Header file excluded from package: C:/Program Files/Microchip/MPLABX/v6.00/packs/Microchip/PIC16Fxxx_DFP/1.3.42/xc8/pic/include/pic_chip_select.h
Header file excluded from package: C:/Program Files/Microchip/MPLABX/v6.00/packs/Microchip/PIC16Fxxx_DFP/1.3.42/xc8/pic/include/proc/pic16f84.h
Header file excluded from package: C:/Program Files/Microchip/MPLABX/v6.00/packs/Microchip/PIC16Fxxx_DFP/1.3.42/xc8/pic/include/xc.h
Packaged project in C:\MPLABX_Projects\16F84_Tests.X\16F84_Tests.zip
Loading code from C:/MPLABX_Projects/16F84_Tests.X/dist/default/production/16F84_Tests.X.production.hex...
Program loaded with pack,PIC16Fxxx_DFP,1.3.42,Microchip
Loading completed
  * 

  */