/*
 * File:   main.c
 * Author: Paul
 *vated on 15 dcembre 2022, 09:13
 */


#include <xc.h>
#define _16F684
#include <builtins.h>
#include <__at.h>
#define _XTAL_FREQ 4000000   // sur Bird

// programmateur POK508 et icprog105d.exe
// CONFIG  3FF2    ( 3FF1 si FOSC=XT)
#pragma config FOSC = XT        // Oscillator Selection bits (XT oscillator)
#pragma config WDTE = OFF       // Watchdog Timer (WDT disabled)
#pragma config PWRTE = ON       // Power-up Timer Enable bit (Power-up Timer is enabled)
#pragma config CP = OFF         // Code Protection bit (Code protection disabled)

//voir as1684_legacy.h
//     as16f684_legacy.h

#define Byte uint8_t
#define Word uint16_t


#define  CR 13
#define  LF 10

#define  TX3_Pin  RA2;
#define  TX3_Pin_Dir TRISA2
#define LED_Dir TRISA4
#define LED    RA4


Byte  c3       __at (0x0020);
Byte RS_Count  __at (0x0021);
Byte  RS_tmp   __at (0x0022);
Byte RS_Delay  __at (0x0023);

Word i,j,k;
Byte Texte[32];
Byte * p1;


void UART3_Write_CText(const char *txt3);
void UART3_Write_Text(unsigned char *T) ;
void CRLF3(void);
void UART3_Write(uint8_t cc);  
void strConstRamCpy(unsigned char *dest, const char *source);


// --- Copie le texte depuis FLASH ROM vers RAM
void strConstRamCpy(unsigned char *dest, const char *source)
 {
  while (*source)
  {
      *dest++ = *source++ ;
  }   
  *dest = 0 ;    // terminateur
}


void UART3_Write_CText(const char *txt3)
 {
   while (*txt3)
     {
     UART3_Write(*txt3++);
    __delay_us(500);
     }
}

void UART3_Write_Text(unsigned char *T)    // at adress  0x002 taille 42 bytes
{
  while(*(T)>0)     // verif sur VBRAY en mode ASCII
   {
    UART3_Write(*(T++));   // c3 variable globale
   }
}

void CRLF3()
{
 UART3_Write(CR);
 UART3_Write(LF);
}


void UART3_Write(uint8_t cc)      // 16MHz 19200 bauds
{
   c3=~cc;    // complement du caractere !
    // avec TX3_PIN => RA2
 __asm("    movlw   8 ");
  __asm("   movwf   _RS_Count");
 __asm("    bcf     PORTA,2 ");
  __asm("   call    RSdelai2");
 __asm(" L00:");
 __asm("    rrcf    _c3,1 ");      
 __asm("    btfsc   STATUS,1 ");    
 __asm("    goto    L10    ");  
 __asm("    bsf     PORTA,2  "); 
 __asm("    goto    L20    ");   
 __asm(" L10:");
 __asm("    bcf     PORTA,2  ");    
 __asm(" L20:");
 __asm("    call    RSdelai2  ");        
 __asm("    decfsz  _RS_Count,1 ");  
 __asm("    goto    L00     ");       
 __asm("    bsf     PORTA,2   ");     
 __asm("    call    RSdelai2   ");   
 __asm("    call    RSdelai2  ");   
 __asm("    goto    LA1");
 __asm(" RSdelai2: "); 
 __asm("    MOVLW 28 ");
 __asm("    MOVWF _RS_tmp ");
 __asm(" RS00:");
 __asm("    NOP");
 __asm("    NOP");
 __asm("    NOP");
 __asm("    NOP");
 __asm("    DECFSZ _RS_tmp,F ");
 __asm("    GOTO   RS00 ");
 __asm("    NOP");
 __asm("    NOP");
 __asm("    NOP");
 __asm("    RETURN ");
__asm("  LA1:  ");
 __asm("    nop");
 }

 void main()
 {
 
  PORTA = 0b00000011;
  TRISA = 0b00000011 ;   // PORTA is RA0,1= analog input  RA2=sortie DAC RA3,4,5=Digital output
  PORTA=0;
  LED_Dir=0;
  LED=0;
  TX3_Pin_Dir=0;
 // TX3_Pin = 1;
  RA2=1;
 
   c3=0;
   RS_Count=0;
   RS_tmp=0;
   RS_Delay=0;
   for (i=0;i<sizeof(Texte);i++) Texte[i]=0;
  
   CRLF3();
  strConstRamCpy(Texte," UART 19200 bds Tx sur RA2 \r\n");
 // *(p1)="16F84 32 bytes seulement";
  UART3_Write_Text(Texte);CRLF3();
  j=0;
  do
  {
    UART3_Write((unsigned char)j+48);
     __delay_ms(1000);
     j++;
     if(j>9) j=0;
     __asm ("BSF PORTA,4");
      __delay_ms(1000);
         __asm ("BCF PORTA,4");
  }   while(1);
  
 }

 
 /*
  * CLEAN SUCCESSFUL (total time: 22ms)
make -f nbproject/Makefile-default.mk SUBPROJECTS= .build-conf
make[1]: Entering directory 'C:/MPLABX_Projects/16F84_Tests.X'
make  -f nbproject/Makefile-default.mk dist/default/production/16F84_Tests.X.production.hex
make[2]: Entering directory 'C:/MPLABX_Projects/16F84_Tests.X'
"C:\Program Files\Microchip\xc8\v2.36\bin\xc8-cc.exe"  -mcpu=16F84 -c   -mdfp="C:/Program Files/Microchip/MPLABX/v6.00/packs/Microchip/PIC16Fxxx_DFP/1.3.42/xc8"  -fno-short-double -fno-short-float -O0 -fasmfile -maddrqual=ignore -xassembler-with-cpp -mwarn=-3 -Wa,-a -DXPRJ_default=default  -msummary=-psect,-class,+mem,-hex,-file  -ginhx32 -Wl,--data-init -mno-keep-startup -mno-osccal -mno-resetbits -mno-save-resetbits -mno-download -mno-stackcall -mdefault-config-bits   -std=c99 -gdwarf-3 -mstack=compiled:auto:auto     -o build/default/production/main.p1 main.c 
::: advisory: (2049) C99 compliant libraries are currently not available for baseline or mid-range devices, or for enhanced mid-range devices using a reentrant stack; using C90 libraries
"C:\Program Files\Microchip\xc8\v2.36\bin\xc8-cc.exe"  -mcpu=16F84 -Wl,-Map=dist/default/production/16F84_Tests.X.production.map  -DXPRJ_default=default  -Wl,--defsym=__MPLAB_BUILD=1   -mdfp="C:/Program Files/Microchip/MPLABX/v6.00/packs/Microchip/PIC16Fxxx_DFP/1.3.42/xc8"  -fno-short-double -fno-short-float -O0 -fasmfile -maddrqual=ignore -xassembler-with-cpp -mwarn=-3 -Wa,-a -msummary=-psect,-class,+mem,-hex,-file  -ginhx32 -Wl,--data-init -mno-keep-startup -mno-osccal -mno-resetbits -mno-save-resetbits -mno-download -mno-stackcall -mdefault-config-bits -std=c99 -gdwarf-3 -mstack=compiled:auto:auto      -Wl,--memorysummary,dist/default/production/memoryfile.xml -o dist/default/production/16F84_Tests.X.production.elf  build/default/production/main.p1     
::: advisory: (2049) C99 compliant libraries are currently not available for baseline or mid-range devices, or for enhanced mid-range devices using a reentrant stack; using C90 libraries

Memory Summary:
    Program space        used   120h (   288) of   400h words   ( 28.1%)
    Data space           used    43h (    67) of    44h bytes   ( 98.5%)
    EEPROM space         used     0h (     0) of    40h bytes   (  0.0%)
    Configuration bits   used     1h (     1) of     1h word    (100.0%)
    ID Location space    used     4h (     4) of     4h bytes   (100.0%)

make[2]: Leaving directory 'C:/MPLABX_Projects/16F84_Tests.X'
make[1]: Leaving directory 'C:/MPLABX_Projects/16F84_Tests.X'

BUILD SUCCESSFUL (total time: 3s)
Loading code from C:/MPLABX_Projects/16F84_Tests.X/dist/default/production/16F84_Tests.X.production.hex...
Program loaded with pack,PIC16Fxxx_DFP,1.3.42,Microchip
Loading completed
  * 

  */